
#define namelen (128)

static char section[namelen];
static u32 readline;

static void readsection(char *str)
{
  str++;
  
  u32 ofs;
  
  ofs=0;
  while(*str!=']'){
    if((namelen<=ofs)||(*str==0)){
      _consolePrintf("line%d error.\nThe section name doesn't end correctly.\n",readline);
      ShowLogHalt();
    }
    section[ofs]=*str;
    str++;
    ofs++;
  }
  section[ofs]=0;
}

static u16 GetColorCoord(const char *value)
{
  u32 v=0;
  
  while(*value!=0){
    char c=*value;
    
    if(('0'<=c)&&(c<='9')){
      v<<=4;
      v|=0x00+(c-'0');
    }
    if(('a'<=c)&&(c<='f')){
      v<<=4;
      v|=0x0a+(c-'a');
    }
    if(('A'<=c)&&(c<='F')){
      v<<=4;
      v|=0x0a+(c-'A');
    }
    
    value++;
  }
  
  u32 r,g,b;
  
  r=(v >> 16) & 0xff;
  g=(v >> 8) & 0xff;
  b=(v >> 0) & 0xff;
  
  return(RGB15(r/8,g/8,b/8) | BIT(15));
}

static void readkey(char *str)
{
  if(section[0]==0){
    _consolePrintf("line%d error.\nThere is a key ahead of the section name.\n",readline);
//    ShowLogHalt();
    return;
  }
  
  char key[namelen],value[namelen];
  
  u32 ofs;
  
  ofs=0;
  while(*str!='='){
    if((namelen<=ofs)||(*str==0)){
      _consolePrintf("line%d error.\nThe key name doesn't end correctly.\n",readline);
      ShowLogHalt();
    }
    key[ofs]=*str;
    str++;
    ofs++;
  }
  key[ofs]=0;
  
  str++;
  
  ofs=0;
  while(*str!=0){
    if(namelen<=ofs){
      _consolePrintf("line%d error.\nThe value doesn't end correctly.\n",readline);
      ShowLogHalt();
    }
    value[ofs]=*str;
    str++;
    ofs++;
  }
  value[ofs]=0;
  
  s32 ivalue=atoi(value);
  bool bvalue;
  
  if(ivalue==0){
    bvalue=false;
    }else{
    bvalue=true;
  }
  
  u16 colvalue=GetColorCoord(value);
  
  if(strcmp(section,"Component")==0){
    TColorTable_Component *pcmp=&ColorTable.Component;
    if(strcmp(key,"Label_Text")==0){
      pcmp->Label_Text=colvalue;
      return;
    }
    if(strcmp(key,"TitleLabel_Text")==0){
      pcmp->TitleLabel_Text=colvalue;
      return;
    }
    if(strcmp(key,"Check_Text")==0){
      pcmp->Check_Text=colvalue;
      return;
    }
    if(strcmp(key,"Button_NormalHighlight")==0){
      pcmp->Button_NormalHighlight=colvalue;
      return;
    }
    if(strcmp(key,"Button_NormalShadow")==0){
      pcmp->Button_NormalShadow=colvalue;
      return;
    }
    if(strcmp(key,"Button_NormalBG")==0){
      pcmp->Button_NormalBG=colvalue;
      return;
    }
    if(strcmp(key,"Button_NormalText")==0){
      pcmp->Button_NormalText=colvalue;
      return;
    }
    if(strcmp(key,"Button_PressHighlight")==0){
      pcmp->Button_PressHighlight=colvalue;
      return;
    }
    if(strcmp(key,"Button_PressShadow")==0){
      pcmp->Button_PressShadow=colvalue;
      return;
    }
    if(strcmp(key,"Button_PressBG")==0){
      pcmp->Button_PressBG=colvalue;
      return;
    }
    if(strcmp(key,"Button_PressText")==0){
      pcmp->Button_PressText=colvalue;
      return;
    }
    if(strcmp(key,"SoftwareScrollBar_Frame")==0){
      pcmp->SoftwareScrollBar_Frame=colvalue;
      return;
    }
    if(strcmp(key,"SoftwareScrollBar_BG")==0){
      pcmp->SoftwareScrollBar_BG=colvalue;
      return;
    }
    
  }
  
  if(strcmp(section,"ErrorDialog")==0){
    TColorTable_ErrorDialog *pct=&ColorTable.ErrorDialog;
    if(strcmp(key,"MessageText")==0){
      pct->MessageText=colvalue;
      return;
    }
    
  }
  
  if(strcmp(section,"FileList")==0){
    TColorTable_FileList *pct=&ColorTable.FileList;
    if(strcmp(key,"FolderNameText")==0){
      pct->FolderNameText=colvalue;
      return;
    }
    if(strcmp(key,"FileNameText")==0){
      pct->FileNameText=colvalue;
      return;
    }
    if(strcmp(key,"SelectText")==0){
      pct->SelectText=colvalue;
      return;
    }
    if(strcmp(key,"PopupBG")==0){
      pct->PopupBG=colvalue;
      return;
    }
    if(strcmp(key,"PopupFrame")==0){
      pct->PopupFrame=colvalue;
      return;
    }
    if(strcmp(key,"PopupText")==0){
      pct->PopupText=colvalue;
      return;
    }
    if(strcmp(key,"ID3TagWhiteModeText")==0){
      pct->ID3TagWhiteModeText=colvalue;
      return;
    }
    if(strcmp(key,"ID3TagBlackModeText")==0){
      pct->ID3TagBlackModeText=colvalue;
      return;
    }
    
  }
  
  if(strcmp(section,"Launch")==0){
    TColorTable_Launch *pct=&ColorTable.Launch;
    if(strcmp(key,"EmptyText")==0){
      pct->EmptyText=colvalue;
      return;
    }
    if(strcmp(key,"FileNameText")==0){
      pct->FileNameText=colvalue;
      return;
    }
    if(strcmp(key,"NDSFileInfoText")==0){
      pct->NDSFileInfoText=colvalue;
      return;
    }
    if(strcmp(key,"SaveFileInfoText")==0){
      pct->SaveFileInfoText=colvalue;
      return;
    }
    
  }
  
  if(strcmp(section,"SystemMenu")==0){
    TColorTable_SystemMenu *pct=&ColorTable.SystemMenu;
    if(strcmp(key,"ItemText")==0){
      pct->ItemText=colvalue;
      return;
    }
    if(strcmp(key,"ItemSelectText")==0){
      pct->ItemSelectText=colvalue;
      return;
    }
    
  }
  
  if(strcmp(section,"Video")==0){
    TColorTable_Video *pct=&ColorTable.Video;
    if(strcmp(key,"InitBG")==0){
      pct->InitBG=colvalue;
      return;
    }
    if(strcmp(key,"FilenameShadow")==0){
      pct->FilenameShadow=colvalue;
      return;
    }
    if(strcmp(key,"FilenameText")==0){
      pct->FilenameText=colvalue;
      return;
    }
    if(strcmp(key,"VolumeShadow")==0){
      pct->VolumeShadow=colvalue;
      return;
    }
    if(strcmp(key,"VolumeText")==0){
      pct->VolumeText=colvalue;
      return;
    }
    if(strcmp(key,"VolumeMaxShadow")==0){
      pct->VolumeMaxShadow=colvalue;
      return;
    }
    if(strcmp(key,"VolumeMaxText")==0){
      pct->VolumeMaxText=colvalue;
      return;
    }
    if(strcmp(key,"InfoBG")==0){
      pct->InfoBG=colvalue;
      return;
    }
    if(strcmp(key,"InfoText")==0){
      pct->InfoText=colvalue;
      return;
    }
    if(strcmp(key,"FrameCacheOff")==0){
      pct->FrameCacheOff=colvalue;
      return;
    }
    if(strcmp(key,"FrameCacheOn")==0){
      pct->FrameCacheOn=colvalue;
      return;
    }
    if(strcmp(key,"FrameCacheWarn")==0){
      pct->FrameCacheWarn=colvalue;
      return;
    }
  }
    
  if(strcmp(section,"TextView")==0){
    TColorTable_TextView *pct=&ColorTable.TextView;
    if(strcmp(key,"MainText")==0){
      pct->MainText=colvalue;
      return;
    }
    if(strcmp(key,"ScrollBar_Frame")==0){
      pct->ScrollBar_Frame=colvalue;
      return;
    }
    if(strcmp(key,"ScrollBar_Inside")==0){
      pct->ScrollBar_Inside=colvalue;
      return;
    }
    if(strcmp(key,"BookmarkMenu_Empty")==0){
      pct->BookmarkMenu_Empty=colvalue;
      return;
    }
    if(strcmp(key,"BookmarkMenu_Exists")==0){
      pct->BookmarkMenu_Exists=colvalue;
      return;
    }
    if(strcmp(key,"PreviewText")==0){
      pct->PreviewText=colvalue;
      return;
    }
    if(strcmp(key,"Line")==0){
      pct->Line=colvalue;
      return;
    }
    
  }
  
  _consolePrintf("line%d error.\ncurrent section [%s] unknown key=%s value=%s\n",readline,section,key,value);
  ShowLogHalt();
}

static void internal_LoadGlobalINI(char *pini,u32 inisize)
{
  section[0]=0;
  readline=0;
  
  u32 iniofs=0;
  
  while(iniofs<inisize){
    
    readline++;
    
    u32 linelen=0;
    
    // Calc Line Length
    {
      char *s=&pini[iniofs];
      
      while(0x20<=*s){
        linelen++;
        s++;
        if(inisize<=(iniofs+linelen)) break;
      }
      *s=0;
    }
    
    if(linelen!=0){
      char c=pini[iniofs];
      if((c==';')||(c=='/')||(c=='!')){
        // comment line
        }else{
        if(c=='['){
          readsection(&pini[iniofs]);
          }else{
          readkey(&pini[iniofs]);
        }
      }
    }
    
    iniofs+=linelen;
    
    // skip NULL,CR,LF
    {
      char *s=&pini[iniofs];
      
      while(*s<0x20){
        iniofs++;
        s++;
        if(inisize<=iniofs) break;
      }
    }
    
  }
}

void LoadColorTable_colortbl_ini(void)
{
  u16 *pchkbuf=(u16*)&ColorTable;
  u32 chkbufsize=sizeof(TColorTable);
  
  MemSet16CPU(0,pchkbuf,chkbufsize);
  
  char *pbuf=NULL;
  s32 bufsize=0;
  
  const char fn[]="colortbl.ini";
  
  _consolePrintf("Load color table. [%s]\n",fn);
  
  u32 fidx=SkinFile_GetFileIndexFromFilename(fn);
  
  if(fidx==(u32)-1){
    _consolePrintf("Fatal error: Skin file '%s' not found.\n",fn);
    ShowLogHalt();
  }
  
  SkinFile_LoadFileAllocate(fidx,(void**)&pbuf,&bufsize);
  
  if((pbuf==NULL)||(bufsize==0)){
    _consolePrintf("File is empty. [%s]\n",fn);
    ShowLogHalt();
  }
  
  internal_LoadGlobalINI(pbuf,bufsize);
  
  safefree(pbuf); pbuf=NULL;
  
  if(ColorTable.FileList.SelectText==0) ColorTable.FileList.SelectText=ColorTable.FileList.FileNameText;
  
  for(u32 idx=0;idx<chkbufsize/2;idx++){
    if((pchkbuf[idx]&BIT15)==0){
      _consolePrintf("Fatal error: The item doesn't suffice for this file. '%s'\n",fn);
      ShowLogHalt();
    }
  }
  
  ColorTable.Component.SoftwareScrollBar_BG=((ColorTable.Component.SoftwareScrollBar_BG & RGB15(30,30,30))>>1)|BIT15;
  ColorTable.TextView.ScrollBar_Inside=((ColorTable.TextView.ScrollBar_Inside & RGB15(30,30,30))>>1)|BIT15;
}

