
static void CB_ROMEO2_HPSwitch_ins_Next(void)
{
  Exec_Next(false);
  ScreenRedrawFlag=true;
}

static void CB_ROMEO2_HPSwitch_ins_Prev(void)
{
  BGM_Prev();
  ScreenRedrawFlag=true;
}

static void CB_ROMEO2_HPSwitch_ins_Pause(void)
{
  if(IPC6->MP2PauseFlag==true){
    IPC6->MP2PauseFlag=false;
    }else{
    IPC6->MP2PauseFlag=true;
  }
  ScreenRedrawFlag=true;
}

#include "PlaySE.h"

static void CB_ROMEO2_HPSwitch_ins_PlaySE(EROMEO2_TriggerType TriggerType,u32 Count,bool AddLong)
{
//  if(TriggerType!=ER2TT_PhoneSwitch) return; // HPSwitchʳʤ鵢
  
  if(AddLong==true) return; // 󥰥⡼ɤϸ̲ʤǵ
  
  PlaySE_Sequence(Count,AddLong);
}

static inline bool CB_ROMEO2_HPSwitch_ins_CheckEnabled(EROMEO2_TriggerType TriggerType)
{
  if(TriggerType==ER2TT_AButton) return(false);
  return(true);
}

static void CB_ROMEO2_HPSwitch_ProcStart(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_ProcStart(...); called.\n");
  
  Process_SeekNext=false;
  Process_SeekPrev=false;
  Process_WaitCount=0;
}

static void CB_ROMEO2_HPSwitch_ProcEnd(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_ProcEnd(...); called.\n");
  
  if((Process_SeekNext==true)||(Process_SeekPrev==true)){
    Process_SeekNext=false;
    Process_SeekPrev=false;
    Process_WaitCount=0;
    
    Resume_SetPos(DPG_GetCurrentFrameCount());
    Resume_Save();
    
    DPG_RequestSyncStart=true;
    SeekBarRedrawCount=0;
    SeekBarExecuteRedraw=true;
    
    IPC6->MP2PauseFlag=false;
    ScreenRedrawFlag=true;
    
    seeking=false;
  }
}

static void CB_ROMEO2_HPSwitch_Down(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_Down(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
}

static void CB_ROMEO2_HPSwitch_Up(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_Up(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
}

static void CB_ROMEO2_HPSwitch_LongStart(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_LongStart(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,0,true);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: {
      Process_SeekPrev=true;
      strpcmStop();
      seeking=true;
    } break;
    case ER2TT_RButton: {
      Process_SeekNext=true;
      strpcmStop();
      seeking=true;
    } break;
    case ER2TT_PhoneSwitch: {
      Process_SeekNext=true;
      strpcmStop();
      seeking=true;
    } break;
  }
}

static void CB_ROMEO2_HPSwitch_LongEnd(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_LongEnd(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
}

static void CB_ROMEO2_HPSwitch_SingleClick(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_SingleClick(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
//  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,1,false);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: case ER2TT_RButton: {
    } break;
    case ER2TT_PhoneSwitch: {
      CB_ROMEO2_HPSwitch_ins_Next();
    } break;
  }
}

static void CB_ROMEO2_HPSwitch_SingleLongStart(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_SingleLongStart(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,1,true);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: {
    } break;
    case ER2TT_RButton: {
    } break;
    case ER2TT_PhoneSwitch: {
      Process_SeekPrev=true;
      strpcmStop();
      seeking=true;
    } break;
  }
}

static void CB_ROMEO2_HPSwitch_SingleLongEnd(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_SingleLongEnd(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
}

static void CB_ROMEO2_HPSwitch_DoubleClick(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_DoubleClick(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,2,false);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: {
      CB_ROMEO2_HPSwitch_ins_Prev();
    } break;
    case ER2TT_RButton: {
      CB_ROMEO2_HPSwitch_ins_Next();
    } break;
    case ER2TT_PhoneSwitch: {
      CB_ROMEO2_HPSwitch_ins_Prev();
    } break;
  }
}

static void CB_ROMEO2_HPSwitch_DoubleLongStart(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_DoubleLongStart(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,2,true);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: {
    } break;
    case ER2TT_RButton: {
    } break;
    case ER2TT_PhoneSwitch: {
    } break;
  }
}

static void CB_ROMEO2_HPSwitch_DoubleLongEnd(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_DoubleLongEnd(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
}

static void CB_ROMEO2_HPSwitch_TripleClick(EROMEO2_TriggerType TriggerType)
{
  _consolePrintf("HPSwitch_TripleClick(...); called.\n");
  
  if(CB_ROMEO2_HPSwitch_ins_CheckEnabled(TriggerType)==false) return;
  CB_ROMEO2_HPSwitch_ins_PlaySE(TriggerType,3,false);
  
  switch(TriggerType){
    case ER2TT_AButton: break;
    case ER2TT_LButton: {
      CB_ROMEO2_HPSwitch_ins_Pause();
    } break;
    case ER2TT_RButton: {
      CB_ROMEO2_HPSwitch_ins_Pause();
    } break;
    case ER2TT_PhoneSwitch: {
      CB_ROMEO2_HPSwitch_ins_Pause();
    } break;
  }
}

